<?php
/*
 * gisweb.php - Copyright 2010 Juan Carlos Cortez Villarreal
 * 
 * this code is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * this code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code.  If not, see <http://www.gnu.org/licenses/>.
 *
 * This code addapts code from :
 * http://demo.mapfish.org/mapfishsample/1.2/demos/geostat/geostat.html
 * http://demo.mapfish.org/mapfishsample/1.2/examples/map/toolbar.html
 * 
 */
?>

<?php
	if (!extension_loaded("MapScript")) dl('php_mapscript.'.PHP_SHLIB_SUFFIX);
?>

<?php 
function label_encode($txt) {
	//tomado de http://us2.php.net/manual/en/language.variables.php

	// add l to the begining to avoid that the resulting
	// label is a javascript keyword or it starts with a
	// number
	$txt = 'l'.$txt;
 
	// encode as urlencoded data
	$txt = rawurlencode($txt);
 
	// replace illegal characters
	$illegal = array('%', '-', '.');
	$ok = array('ì', 'è', 'à');
	$txt = str_replace($illegal,$ok, $txt);
 
	return $txt;
}

function label_decode($txt) {
	//tomado de http://us2.php.net/manual/en/language.variables.php 

	// replace illegal characters
	$illegal = array('%', '-', '.');
	$ok = array('ì', 'è', 'à');
	$txt = str_replace($ok, $illegal, $txt);

	// unencode
	$txt = rawurldecode($txt);
 
	// remove the leading Z and return
	return substr($txt,1);
}

function lnonly($string) {
	// Tomado de: http://www.codewalkers.com/c/a/Miscellaneous-Code/Letters-Numbers-Only/

	$eregi = eregi_replace("([a-zA-Z0-9]+)","",$string);
	if(empty($eregi)){
		return true;
	}
	return false;
}

$nombreMapa = $_GET['gis'];
if (!lnonly($nombreMapa)) exit("Error en el parametro 'mapa' del url.");
$jMap = ms_newMapObj("/gismap/".$nombreMapa.".map");
$wms_title=$jMap->web->metadata->get("wms_title");
$wms_srs=strtok(trim($jMap->web->metadata->get("wms_srs")), " ");
$wms_onlineresource=$jMap->web->metadata->get("wms_onlineresource");
$map_extent=$jMap->extent;
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<title>Visualizador de Mapas</title>
	<link rel="stylesheet" type="text/css" href="/mfbase/ext/resources/css/ext-all.css"/>
	
	<style type="text/css">
	html, body {
		font: normal 12px verdana;
		margin: 0;
		padding: 0;
		border: 0 none;
		overflow: hidden;
		height: 100%;
		width: 100%;
	}

	ul.list {
		list-style-type: disc;
		font-size: 11px;
		padding: 0 0 0 16px;
	}
    
	#loading{
		position:absolute;
		width: 100%;
		height: 100%;
		z-index:20001;
	}
	#loading a {
		color:#225588;
	}
	#loading .loading-mask {
		padding:2px;
		width: 100%;
		height: 100%;
		-moz-opacity: 0.5;
		opacity: .50;
		filter: alpha(opacity=50);
		background-color: white;
	}
	#loading .loading-container {
		position:absolute;
		left:45%;
		top:40%;
		height:auto;
		border:1px solid #ccc;
	}
	#loading .loading-indicator {
		background:white;
		color:#444;
		font:bold 13px tahoma,arial,helvetica;
		padding:10px;
		margin:0;
		height:auto;
	}
	#loading-msg {
		font: normal 10px arial,tahoma,sans-serif;
	}
	.olControlOverviewMapElement {
		background-color: transparent !important;
		padding: 0 0 0 0  !important;
	}

	.cf-wms-node img.x-tree-node-icon {
		  width: auto !important;
		  height: auto !important;
	}

	.float-left {
		float: left;
	}
	.clear-left {
		clear: left;
	}

	.zoomin {
		background-image:url(/mfbase/mapfish/img/icon_zoomin.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.zoomout {
		background-image:url(/mfbase/mapfish/img/icon_zoomout.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.zoomfull {
		background-image:url(/mfbase/mapfish/img/icon_zoomfull.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.pan {
		background-image:url(/mfbase/mapfish/img/icon_pan.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.next {
		background-image:url(/mfbase/mapfish/img/resultset_next.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.back {
		background-image:url(/mfbase/mapfish/img/resultset_previous.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.identify {
		background-image:url(/mfbase/mapfish/img/query.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.distance {
		background-image:url(/mfbase/mapfish/img/distance_off.png) !important;
		height:20px !important;
		width:20px !important;
	}
	.area {
		background-image:url(/mfbase/mapfish/img/area_off.png) !important;
		height:20px !important;
		width:20px !important;
	}
	</style>
  
	<!-- EXT colorField Extent -->
	<link rel="stylesheet" type="text/css" href="/mfbase/ext-community-extensions/color-field.css" />
</head>

<body>
	<div id="loading">
		<div class="loading-mask"></div>
		<div class="loading-container">
			<div class="loading-indicator">
				<img src="/mfbase/ext/resources/images/default/shared/large-loading.gif" width="32" height="32" style="margin-right:8px;float:left;vertical-align:top;"/>Blog GIS de JC<br /><span id="loading-msg">Cargando ...</span>
			</div>
		</div>
	</div>

	<div id="north" style="padding: 5px">
		<h1 style="font-size: 20px;"><?php echo $wms_title; ?></h1>
	</div>
	<div id="olmap"></div>
	<div id="south"><p></p></div>
	<div id="position"><div id="mouseposition"></div></div>        
</body>

<script type="text/javascript" src="/mfbase/ext/adapter/ext/ext-base.js"></script>
<script type="text/javascript" src="/mfbase/ext/ext-all.js"></script>

<!-- debug mode -->

<script type="text/javascript" src="/mfbase/openlayers/lib/OpenLayers.js"></script>
<script type="text/javascript" src="/mfbase/mapfish/MapFish.js"></script>

<!-- production mode -->
<!--<script type="text/javascript" src="/mfbase/release/mapfish/MapFish.js"></script>-->

<!-- EXT colorField Extent -->
<script type="text/javascript" src="/mfbase/ext-community-extensions/color-field.js" ></script>

<script type="text/javascript">

	// reference local blank image
	Ext.BLANK_IMAGE_URL = '/mfbase/ext/resources/images/default/s.gif';
	var tree,nodo,map,toolbar,queryEventHandler,req ;
	Ext.onReady(function() {
		Ext.state.Manager.setProvider(new Ext.state.CookieProvider());

		var options = {
			units:'meters',
			maxExtent: new OpenLayers.Bounds(<?php echo $map_extent->minx.",".$map_extent->miny.",".$map_extent->maxx.",".$map_extent->maxy; ?>),
			projection:new OpenLayers.Projection("<?php echo $wms_srs; ?>"),
			maxResolution: <?php echo ($map_extent->maxx-$map_extent->minx)/200; ?>,
			maxZoomLevel: 10
		};
		map = new OpenLayers.Map('olmap', options);
<?php
	$jCapas=$jMap->getAllLayerNames();
	foreach ($jCapas as $idx => $layer) {
		$capaObj=$jMap->getLayerByName($layer);
		$esBase=false;
		if ($capaObj->metadata->get("JC_BASE")!="")
			$esBase=$capaObj->metadata->get("JC_BASE");
		else
			if ($capaObj->type==MS_LAYER_POLYGON || $capaObj->type==MS_LAYER_RASTER)
				$esBase=true;
			else
				$esBase=false;
		$visibility=($capaObj->status==MS_ON?"true":"false");
		$singleTile=(($capaObj->labelitem!="")?"true":"false");
		echo "\t\t".label_encode($capaObj->name).
				" = new OpenLayers.Layer.WMS(".
				"\"{$capaObj->name}\",".
				"\"{$wms_onlineresource}\",".
				"{".
					"units:'m',".
					"layers:'{$capaObj->name}',".
					"transparent:true,".
					"format:'image/png',".
					"'VERSION':\"1.1.1\"".
				"},".
				"{".
					"isBaseLayer:".$esBase.",".
					"projection: new OpenLayers.Projection(\"{$wms_srs}\"),".
					"visibility:".$visibility.",".
					"singleTile:".$singleTile.
				"}".
				");\n";
		echo "\t\tmap.addLayers([".label_encode($capaObj->name)."]);\n";
		echo "\t\tmap.raiseLayer(".label_encode($capaObj->name).",-".$idx.");\n";
	}
?>
		map.zoomToMaxExtent();

		var model = 
			[
<?php
	$primero=true; $grupo='';
	foreach ($jCapas as $idx => $layer) {
		$capaObj=$jMap->getLayerByName($layer);
		if ($grupo!=$capaObj->getMetaData('wms_layer_group'))
		{
			if ($grupo!='')
			{
				echo "\t\t\t\t ]\n".
				"\t\t\t }\n";
			}
			$grupo=$capaObj->getMetaData('wms_layer_group');
			if ($grupo!='')
			{
				if ($primero) $primero=false; else echo "\t\t\t ,\n";
				echo 	"\t\t\t {\n".
					"\t\t\t\t text:\"{$grupo}\",\n".
					"\t\t\t\t leaf:false,\n".
					"\t\t\t\t expanded:true,\n".
					"\t\t\t\t children:[\n";
			}
			
		}
		else if ($primero) $primero=false; else echo "\t\t\t ,\n";

		echo 		"\t\t\t {\n".
				"\t\t\t\t text:\"{$capaObj->getMetaData('wms_title')}\",\n",
				"\t\t\t\t layerName:\"{$capaObj->name}\",\n",
				"\t\t\t\t checked:false,\n";
		if (($capaObj->numclasses)>1){
			echo 	"\n".
				"\t\t\t\t leaf:false,\n".
				"\t\t\t\t expanded:false,\n".
				"\t\t\t\t children:[\n";
			$primero2=true;
			for($i=0;$capaObj->getClass($i);$i++){
				if ($primero2) $primero2=false; else echo "\t\t\t\t ,\n";
				$Class = $capaObj->getClass($i);
				echo
					"\t\t\t\t {\n".
					"\t\t\t\t\t text:\"{$Class->name}\",\n".
					"\t\t\t\t\t icon:\"".$wms_onlineresource.(strstr($wms_onlineresource,"?")?"&":"?").
										"LAYER=".rawurlencode($capaObj->name).
										"&RULE=".rawurlencode($Class->name).
										"&SERVICE=WMS".
										"&VERSION=1.1.1".
										"&REQUEST=GetLegendGraphic".
										"&FORMAT=image%2Fpng".
										"&WIDTH=16".
										"&HEIGHT=16\",".
					"\t\t\t\t\t leaf:true\n".
					"\t\t\t\t }\n";
			}
			echo "\t\t\t\t ]\n";

		}
		else{
			echo 	"\n".
				"\t\t\t\t leaf:true,\n".
				"\t\t\t\t icon:\"".$wms_onlineresource.(strstr($wms_onlineresource,"?")?"&":"?").
					"LAYER=".rawurlencode($capaObj->name).
					"&RULE=".rawurlencode($capaObj->getClass(0)->name).
					"&SERVICE=WMS".
					"&VERSION=1.1.1".
					"&REQUEST=GetLegendGraphic".
					"&FORMAT=image%2Fpng".
					"&WIDTH=16&HEIGHT=16\"\n";
		}
		echo "\t\t\t }\n";
	}
	if ($grupo!='')
		echo "\t\t\t ]\n\t\t\t}\n";
?>
			];

		createToolbar();
		// create viewport
		var viewport = new Ext.Viewport({
			layout: 'border',
			items:[
				new Ext.BoxComponent({ // raw
					region: 'north',
					el: 'north',
					height: 32
				}),{
					region: 'south',
					contentEl: 'south',
					id: 'south-panel',
					split: true,
					initialSize: 100,
					height:100,
					minSize: 20,
					maxSize: 200,
					collapsible: true,
					title: 'Mensaje',
					autoScroll:true,
					margins: '0 0 0 0'
				},{
					region: 'west',
					title: ' ',
					width: 250,
					minSize: 175,
					maxSize: 500,
					collapsible: true,
					margins: '0 5 0 0',
					defaults: {
						border: true,
						frame: true
					},
					layout: 'border',
					items: [
					{
						title: 'Capas',
						region: 'center',
						html:'<div id="tree" style="height:100%;"></div>',
						autoScroll:true,
						listeners: {
							resize: function(panel, w, h) {
								if (tree) { tree.setSize(w-12,h-35);}
							}
						}
					},{
						title: 'Posición',
						region: 'south',
						collapsible: true,
						height: 65,
						contentEl: 'position'
					}]
				},{
					region: 'east',
					title: ' ',
					split: true,
					collapsible: true,
					width: 200,
					minSize: 175,
					maxSize: 500,
					margins: '0 0 0 5',
					layout: 'border',
					defaults: {
						border: true,
						frame: true
					},
					items: [
					{
						title: 'Descripción',
						html: '<p>Este es un script PHP/Mapscript que genera dinámicamente un cliente MapFish acorde con archivo de configuracion .map</p>',
						border: false,
						region: 'center',
						autoScroll:true
					},
					{
						title: 'Ubicación',
						region: 'south',
						height: 150,
						collapsible:true,
						html:'<div id="overviewmap"></div>'
					}
					]
				},{
					region: 'center',
					title: 'Mapa',
					xtype: 'mapcomponent',
					tbar: toolbar,
					map: map
				}
			]
		});
		map.addControl(new OpenLayers.Control.MousePosition(
		{
			displayClass: "void", 
			div: $('mouseposition'), 
			prefix: 'x: ',
			separator: '<br/>y: '
		}));
		mapita=new OpenLayers.Control.OverviewMap(
		{
			div: $('overviewmap'),
			mapOptions:{
				maxResolution: <?php echo ($map_extent->maxx-$map_extent->minx)/50; ?>, 
				minResolution: <?php echo ($map_extent->maxx-$map_extent->minx)/400; ?>
			}
		});  
		map.addControl(mapita);

		tree = new mapfish.widgets.LayerTree(
		{
			map:map, el: $('tree'), model: model,
			plugins:[
				mapfish.widgets.LayerTree.createContextualMenuPlugin(['opacitySlideDirect','zoomToExtent'])
			],
			listeners: {
				click: function(nodox, e) {
					nodo=nodox;
					if (nodox.attributes.checked!=undefined) 
					{
						var html = 'Capa <b>'+ nodox.attributes.text +'</b> Seleccionada<br />';    
						var infoPanel = Ext.getCmp('south-panel');
						infoPanel.body.dom.innerHTML = html;
					}
				}
			}
		});
		tree.render();
		queryEventHandler = new OpenLayers.Handler.Click({ 'map': map }, { 'click': function(e) { doIdentify(e); } });      
		initializeToolbar();
		Ext.get('loading').fadeOut({remove: true});
	});

	function addSeparator(toolbar){
		toolbar.add(new Ext.Toolbar.Spacer());
		toolbar.add(new Ext.Toolbar.Separator());
		toolbar.add(new Ext.Toolbar.Spacer());
	} 

	var createToolbar = function() {
		toolbar = new mapfish.widgets.toolbar.Toolbar({
			map: map,
			configurable: false
		});
		// this is a quick fix for http://trac.mapfish.org/trac/mapfish/ticket/126
		toolbar.autoHeight = false;
		toolbar.height = 25;
	}; 
	
    var initializeToolbar = function() {
		toolbar.addControl(
			new OpenLayers.Control.ZoomToMaxExtent({
				map: map,
				title: 'Zoom a la máxima extensión del mapa'
			}), {
				iconCls: 'zoomfull', 
				toggleGroup: 'map'
			}
		);
            
		addSeparator(toolbar);
        
		toolbar.addControl(
			new OpenLayers.Control.ZoomBox({
				title: 'Acercamiento: hacer click en el mapa y arrastrar para crear un rectángulo'
			}), {
				iconCls: 'zoomin', 
				toggleGroup: 'map'
			}
		);
	
		toolbar.addControl(
			new OpenLayers.Control.ZoomBox({
				out: true,
				title: 'Alejamiento: hacer click en el mapa y arrastrar para crear un rectángulo'
			}), {
				iconCls: 'zoomout', 
				toggleGroup: 'map'
			}
		);
		
		toolbar.addControl(
				new OpenLayers.Control.DragPan({
				isDefault: true,
				title: 'Desplazamiento: mantener el click izquierdo del mouse para desplazarse sobre el mapa'
			}), {
				iconCls: 'pan', 
				toggleGroup: 'map'
			}
		);
	     
		featureInfo=new OpenLayers.Control({
			title: 'Información: Seleccionar una capa y hacer click en el mapa',
			type: OpenLayers.Control.TYPE_TOOL
		});
		featureInfo.events.remove("activate");
		featureInfo.events.remove("deactivate");

		toolbar.addControl(featureInfo,
			{
				iconCls: 'identify',
				toggleGroup: 'map'
			}
		);
		featureInfo.events.register("activate", 
			featureInfo, 
			function() { toggleQueryMode(); }
		);                
		featureInfo.events.register("deactivate", 
			featureInfo, 
			function() { toggleQueryMode(); }
		);

		addSeparator(toolbar);

		nav = new OpenLayers.Control.NavigationHistory();
		map.addControl(nav);
		nav.activate();
            
		toolbar.add(
			new Ext.Toolbar.Button({
				iconCls: 'back',
				tooltip: 'Vista anterior', 
				handler: nav.previous.trigger
			})
		);

		toolbar.add(
			new Ext.Toolbar.Button({
				iconCls: 'next',
				tooltip: 'Vista siguiente', 
				handler: nav.next.trigger
			})
		);
		addSeparator(toolbar);

		// register events to the featureInfo tool
		toolbar.activate();
    }
	
	function toggleQueryMode()
	{             
		if(featureInfo.active) {
			queryEventHandler.activate();
			map.getControlsByClass('OpenLayers.Control.Navigation')[0].deactivate();
		}
		else {
			queryEventHandler.deactivate();
		}
	}

	function doIdentify(evt)
	{
		if (nodo && nodo.attributes.layerNames && nodo.attributes.layerNames[0])
		{
			var activeLayer=map.getLayersByName(nodo.attributes.layerNames[0])[0];
			var url = activeLayer.getFullRequestString({
                                REQUEST: "GetFeatureInfo",
                                EXCEPTIONS: "application/vnd.ogc.se_xml",
                                BBOX: map.getExtent().toBBOX(),
                                X: evt.xy.x,
                                Y: evt.xy.y,
                                INFO_FORMAT: 'text/html',
                                QUERY_LAYERS: activeLayer.params.LAYERS,
                                WIDTH: map.size.w,
                                HEIGHT: map.size.h});
			loadXMLDoc(url);
		}
	}

	function loadXMLDoc(url) {
		//Tomado de : http://www.xml.com/lpt/a/1535
		
		req = false;
	    // branch for native XMLHttpRequest object
	    if(window.XMLHttpRequest && !(window.ActiveXObject)) {
	    	try {
				req = new XMLHttpRequest();
	        } catch(e) {
				req = false;
	        }
	    // branch for IE/Windows ActiveX version
	    } else if(window.ActiveXObject) {
	       	try {
	        	req = new ActiveXObject("Msxml2.XMLHTTP");
	      	} catch(e) {
	        	try {
	          		req = new ActiveXObject("Microsoft.XMLHTTP");
	        	} catch(e) {
	          		req = false;
	        	}
			}
	    }
		if(req) {
			req.onreadystatechange = processReqChange;
			req.open("GET", url, true);
			req.send("");
		}
	}
	
	function processReqChange() {
		// Tomado de: http://www.xml.com/lpt/a/1535
	
		// only if req shows "loaded"
		if (req.readyState == 4) {
			// only if "OK"
			if (req.status == 200) {
				// ...processing statements go here...
				var infoPanel = Ext.getCmp('south-panel');
				infoPanel.body.dom.innerHTML = req.responseText;
			} else {
				alert("There was a problem retrieving the XML data:\n" +
				req.statusText);
			}
		}
	}
</script>
</html>
